﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;

namespace WinSpd2 {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
        }

        private DataTable MainDBAdapter;

        private void Form1_Load(object sender, EventArgs e) {
            InitTableSchema();
            InitSpread();

            (new Thread(lambda => {
                while (true) {
                    for (int i = 0; i < 700; i++) {
                        DataRow dataRow = MainDBAdapter.Rows.Find("A" + i.ToString("00000000"));
                        if (dataRow == null)
                            continue;

                        SpreadRowUpdate(dataRow, i, false);
                        SpreadUi("A" + i.ToString("00000000"));
                        Thread.Sleep(100);
                    }
                }
            }) { Name = "Updatedata", IsBackground = true }).Start();
        }

        private void SpreadUi(string data) {
            this?.BeginInvoke((Action)(() => {
                int row = 0;
                int col = 0;
                SpdMain.Search(SpdMain.ActiveSheetIndex, data, false, true, false, false, 0, 0, SpdMain.ActiveSheet.RowCount - 1, 0, ref row, ref col);
                if (row >= 0) {
                    SpdMainSheet.ActiveRowIndex = row;
                    SpdMain.ShowActiveCell(FarPoint.Win.Spread.VerticalPosition.Top, FarPoint.Win.Spread.HorizontalPosition.Center);
                }
            }));
        }

        private void InitTableSchema() {
            MainDBAdapter = new DataTable();
            for (int i = 0; i < SpdMainSheet.ColumnCount; i++) {
                MainDBAdapter.Columns.Add(new DataColumn(SpdMainSheet.ColumnHeader.Columns[i].Label, System.Type.GetType("System.String")));
            }
            MainDBAdapter.PrimaryKey = new DataColumn[] { MainDBAdapter.Columns["A"] };
        }


        private void InitSpread() {
            try {
                SpdMain.SuspendLayout();

                SpdMainSheet.AutoCalculation = false;
                SpdMainSheet.DataSource = null;
                SpdMainSheet.DataAutoSizeColumns = false;
                MainDBAdapter.Rows.Clear();

                SpdMainSheet.RowCount = 700;
                SpdMainSheet.ClearRange(0, 0, SpdMainSheet.RowCount, SpdMainSheet.ColumnCount, true);
                SpdMainSheet.SetActiveCell(0, 0);

                for (int i = 0; i < 700; i++) {
                    DataRow dataRow = MainDBAdapter.NewRow();
                    SpreadRowUpdate(dataRow, i, true);
                    MainDBAdapter.Rows.Add(dataRow);
                }
                SpdMainSheet.DataSource = MainDBAdapter;
                SpdMain.ResumeLayout(true);
            } catch (Exception ex) {
                System.Console.WriteLine(ex.ToString());
            }
        }


        private void SpreadRowUpdate(DataRow dataRow, int count, bool Init) {
            dataRow.BeginEdit();
            if (Init) {
                for (int i = 0; i < SpdMainSheet.ColumnCount - 1; i++) {
                    dataRow[SpdMainSheet.Columns[i].Label] = SpdMainSheet.Columns[i].Label + count.ToString("00000000");
                }
            } else {
                for (int i = 2; i < SpdMainSheet.ColumnCount - 1; i++) {
                    dataRow[SpdMainSheet.Columns[i].Label] = SpdMainSheet.Columns[i].Label + DateTime.Now.ToString("HHmmssfff");
                }
            }
            dataRow.EndEdit();
        }
    }
}
